/****************************************************************************/
/* Copyright SORCUS Computer GmbH 2002	                                     */ 
/****************************************************************************/
// CANSMPLDlg.h : Header-Datei
//

// SORCUS header:
#include "max_lib.h"
#include "x_error.h"
#include "x_mdd.h"

#if !defined(AFX_CANSMPLDLG_H__93DC3AC5_C402_11D6_B242_00104B69AAD2__INCLUDED_)
#define AFX_CANSMPLDLG_H__93DC3AC5_C402_11D6_B242_00104B69AAD2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCANSMPLDlg Dialogfeld

class CCANSMPLDlg : public CDialog
{
// Konstruktion
public:
	static MAX_CALLBACK msgcallback(MAXCHLHND handle, ULONG par, ULONG size, void *pData);
	static MAX_CALLBACK buscallback(MAXCHLHND handle, ULONG par, ULONG size, void *pData);
	MAXCHLHND m_hReceiver;
	MAXCHLHND m_hTransmitter;
	MAXMDDHND m_hXCanMdd;
	MAXMODHND m_hCPU;
	CCANSMPLDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CCANSMPLDlg)
	enum { IDD = IDD_CANSMPL_DIALOG };
	CEdit	m_Event;
	CComboBox	m_BitTiming;
	UINT	m_Board;
	UINT	m_Channel;
	UINT	m_XCanSlot;
	CString	m_VersionInfo;
	BOOL	m_IDFormat;
	BOOL	m_BusResistor;
	DWORD	m_TmtID;
	BOOL	m_TmtExclBuffer;
	BOOL	m_TmtNoInt;
	BOOL	m_TmtRemote;
	CString	m_TmtData;
	DWORD	m_RcvID;
	BOOL	m_RcvExclBuffer;
	BOOL	m_RcvActive;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CCANSMPLDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CCANSMPLDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonStart();
	afx_msg void OnButtonBuscfg();
	afx_msg void OnButtonTmtCreate();
	afx_msg void OnButtonTmt();
	afx_msg void OnButtonRcvCreate();
	afx_msg void OnButtonRcv();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_CANSMPLDLG_H__93DC3AC5_C402_11D6_B242_00104B69AAD2__INCLUDED_)
