#include "max_lib.h"
#include "x_error.h"
#include "x_mdd.h"

// program number of the buf_dacq.exe realtime program
#define DAQ_PROG_NO           0x9014

// all structs are word aligned
#ifndef _RTLIB_
   #pragma pack(push, SORCPACK, 2)
#endif

// data struct expected by function 2 of the realtime program
typedef struct {
   USHORT      usADSlot;
   USHORT      usInputMode;
   USHORT      usInputRange;
   USHORT      usSettleTime;
   USHORT      usFirstChannel;
   USHORT      usLastChannel;
} DAQ_INIT_DATA;

#ifndef _RTLIB_
   #pragma pack(pop, SORCPACK)
#endif
