// ExDacDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "ExDac.h"
#include "ExDacDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern "C" __declspec(dllimport) unsigned long _stdcall InitMeasurement(ULONG ulBoardNumber, ULONG ulXmax1Slot, ULONG ulXad1420Slot, ULONG ulNumberOfData, double dFrequency);
extern "C" __declspec(dllimport) unsigned long _stdcall ReadAin(ULONG ulChannelIndex, LONG* plData, ULONG* pulDataIndex);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExDacDlg Dialogfeld

CExDacDlg::CExDacDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExDacDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExDacDlg)
	m_ul_board_number = 0;
	m_d_frequency = 0.0;
	m_ul_number_of_data = 0;
	m_ul_xad1420_slot = 0;
	m_ul_xmax1_slot = 0;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExDacDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExDacDlg)
	DDX_Text(pDX, IDC_EDIT_BOARD_NUMBER, m_ul_board_number);
	DDX_Text(pDX, IDC_EDIT_FREQUENCY, m_d_frequency);
	DDX_Text(pDX, IDC_EDIT_NUMBER_OF_DATA, m_ul_number_of_data);
	DDX_Text(pDX, IDC_EDIT_XAD1420_SLOT, m_ul_xad1420_slot);
	DDX_Text(pDX, IDC_EDIT_XMAX1_SLOT, m_ul_xmax1_slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExDacDlg, CDialog)
	//{{AFX_MSG_MAP(CExDacDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START_MEASUREMENT, OnButtonStartMeasurement)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExDacDlg Nachrichten-Handler

BOOL CExDacDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

    ///////////////////////////////////////////////////////////
	// OSCOPE
    ///////////////////////////////////////////////////////////
	CRect rect;

	GetDlgItem(IDC_OSCOPE1)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_OScopeCtrl1.Create(WS_VISIBLE | WS_CHILD, rect, this);
	m_OScopeCtrl1.SetRange(-10.0, 10.0, 1);
	m_OScopeCtrl1.SetYUnits("Volt");
	m_OScopeCtrl1.SetXUnits("AIN-0");

	GetDlgItem(IDC_OSCOPE2)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_OScopeCtrl2.Create(WS_VISIBLE | WS_CHILD, rect, this);
	m_OScopeCtrl2.SetRange(-10.0, 10.0, 1);
	m_OScopeCtrl2.SetYUnits("Volt");
	m_OScopeCtrl2.SetXUnits("AIN-1");

    ///////////////////////////////////////////////////////////

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CExDacDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CExDacDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CExDacDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



/******************************************************************************
*								OnButtonStartMeasurment
*	PURPOSE
*	REMARK
*	PARAMETER
*	RETURN
*	HISTORY
******************************************************************************/
void CExDacDlg::OnButtonStartMeasurement() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen

    ULONG ulError, ulIndex, ulDataIndex;
    LONG lData;
    DOUBLE dData;

    UpdateData(TRUE);

    // clear oscopes
    m_OScopeCtrl1.InvalidateCtrl();
    m_OScopeCtrl2.InvalidateCtrl();

    // show wait cursor
    CWaitCursor cursor;

    // init and start measurement
    ulError = InitMeasurement(m_ul_board_number, m_ul_xmax1_slot, m_ul_xad1420_slot, m_ul_number_of_data, m_d_frequency);
    
    // check error
    if (ulError != 0)
    {
        AfxMessageBox("Error at InitMeasurement", MB_ICONERROR);
        return;
    }
    

    // show data
    do
    {
        ulError = ReadAin(0, &lData, &ulDataIndex);
        if (ulError == 0)
        {
            dData = ((DOUBLE)lData/1000000.0);
            m_OScopeCtrl1.AppendPoint(dData);
            ulIndex = ulDataIndex;
        }
        else
        {
            ulIndex = 0;
        }

        ulError = ReadAin(1, &lData, &ulDataIndex);
        if (ulError == 0)
        {
            dData = ((DOUBLE)lData/1000000.0);
            m_OScopeCtrl2.AppendPoint(dData);
            ulIndex = ulDataIndex;
        }
        else
        {
            ulIndex = 0;
        }

        // show data slowly
        Sleep(1);

        // update oscopes
        m_OScopeCtrl1.UpdateWindow();
        m_OScopeCtrl2.UpdateWindow();

    }while(ulIndex < m_ul_number_of_data-1);
}
