// XAD244TestDlg.h : Header-Datei
//

#if !defined(AFX_XAD244TESTDLG_H__DF357E76_EE9D_4540_8E53_0B1EA5E53B5F__INCLUDED_)
#define AFX_XAD244TESTDLG_H__DF357E76_EE9D_4540_8E53_0B1EA5E53B5F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CXAD244TestDlg Dialogfeld

class CXAD244TestDlg : public CDialog
{
// Konstruktion
public:
	CXAD244TestDlg(CWnd* pParent = NULL);	// Standard-Konstruktor
	static MAX_CALLBACK CbNewData(MAXCHLHND hChannel, DWORD dwParam, DWORD dwSize, void* pData);
	static CXAD244TestDlg* m_pDlg;
	// Dialogfelddaten
	//{{AFX_DATA(CXAD244TestDlg)
	enum { IDD = IDD_XAD244TEST_DIALOG };
	UINT			m_nIndexFirst;
	UINT			m_nIndexLast;
	int			m_nMode;
	UINT			m_nFilter;
	BOOL			m_tHwFormat;
	BOOL			m_tUncorrected;
	BOOL			m_tNewDataCallback;
	DWORD			m_ulSensor;
	UINT			m_nOversampling;
	BOOL			m_tDinPosEdge;
	BOOL			m_tDinNegEdge;
	CString		m_strAin0;
	CString		m_strAin1;
	CString		m_strAin2;
	CString		m_strAin3;
	CString		m_strDin0;
	CString		m_strDin1;
	CString		m_strDin2;
	CString		m_strDin3;
	DWORD	m_ulCallbackCount;
	BOOL	m_tAutoRead;
	//}}AFX_DATA
	MAXMDDHND	m_hMdd;
	CPS_XAD244I	m_sCpsAin;
	CPS_XAD244I	m_sCpsDin;
	MAXCHLHND	m_hAin;
	MAXCHLHND	m_hDin;
	USHORT		m_usSubType;
	double		m_dDivider;
	UINT			m_nDinTimer;
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CXAD244TestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CXAD244TestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOpenAinButton();
	afx_msg void OnReadAinButton();
	afx_msg void OnCloseAinButton();
	afx_msg void OnCalib1AinButton();
	afx_msg void OnCalib2AinButton();
	afx_msg void OnOpenDinButton();
	afx_msg void OnReadDinButton();
	afx_msg void OnCloseDinButton();
	afx_msg void OnLinButton();
	afx_msg void OnAutoReadDinCheck();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_XAD244TESTDLG_H__DF357E76_EE9D_4540_8E53_0B1EA5E53B5F__INCLUDED_)
