// dad4slaveDlg.h : Header-Datei
//
// SORCUS header:
#include "max_lib.h"
#include "x_error.h"
#include "x_mdd.h"

#if !defined(AFX_DAD4SLAVEDLG_H__038CB105_9D73_11D6_B1FF_00104B69AAD2__INCLUDED_)
#define AFX_DAD4SLAVEDLG_H__038CB105_9D73_11D6_B1FF_00104B69AAD2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDad4slaveDlg Dialogfeld

class CDad4slaveDlg : public CDialog
{
// Konstruktion
public:
	USHORT m_usStartCommunication;
	static MAX_CALLBACK BusCtrlCallback(MAXCHLHND hChl, ULONG ulParam, ULONG ulSize, void *pData);
	static MAX_CALLBACK DataCallback(MAXCHLHND hChl, ULONG ulParam, ULONG ulSize, void *pData);
	MAX_ERROR Configuration(void);
	USHORT Operate (void);
	UINT m_nTimer;
	CDad4slaveDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CDad4slaveDlg)
	enum { IDD = IDD_DAD4SLAVE_DIALOG };
	CEdit	m_Events;
	BOOL	m_Din0;
	BOOL	m_Din1;
	BOOL	m_Din2;
	BOOL	m_Din3;
	BOOL	m_Din4;
	BOOL	m_Din5;
	BOOL	m_Din6;
	BOOL	m_Din7;
	BOOL	m_Dout0;
	BOOL	m_Dout1;
	BOOL	m_Dout2;
	BOOL	m_Dout3;
	BOOL	m_Dout4;
	BOOL	m_Dout5;
	BOOL	m_Dout6;
	BOOL	m_Dout7;
	long	m_Aout0;
	long	m_Aout1;
	long	m_Aout2;
	long	m_Aout3;
	long	m_Ain0;
	long	m_Ain1;
	long	m_Ain2;
	long	m_Ain3;
	UINT	m_Board;
	UINT	m_SlotDAD4;
	UINT	m_SlotDPS2;
	UINT	m_Station;
	UINT	m_Channel;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CDad4slaveDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CDad4slaveDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClose();
	afx_msg void OnButtonStart();
	afx_msg void OnInfoState();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_DAD4SLAVEDLG_H__038CB105_9D73_11D6_B1FF_00104B69AAD2__INCLUDED_)
