#include "max_lib.h"
#include "x_mdd.h"

// testxsccDlg.h : Header-Datei
//

#if !defined(AFX_TESTXSCCDLG_H__50BFD112_A07E_443B_A0A2_C50395A6D145__INCLUDED_)
#define AFX_TESTXSCCDLG_H__50BFD112_A07E_443B_A0A2_C50395A6D145__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CTestxsccDlg Dialogfeld

class CTestxsccDlg : public CDialog
{
// Konstruktion
public:
	static MAX_CALLBACK MyCallback(MAXCHLHND hChannel, ULONG ulParam, ULONG ulSize, void *pData);
	void SetWR(UCHAR ucReg, CString sData);
	void UpdateRegister(void);
	CTestxsccDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CTestxsccDlg)
	enum { IDD = IDD_TESTXSCC_DIALOG };
	CComboBox	m_Stopbit;
	CComboBox	m_Parity;
	CComboBox	m_BPC;
	CComboBox	m_TRxC;
	CComboBox	m_RTxC;
	CComboBox	m_Interface;
	BOOL	m_IntOnBRK;
	BOOL	m_IntOnCTS;
	BOOL	m_IntOnDCD;
	BOOL	m_DTRInternal;
	BOOL	m_IntOnParity;
	BOOL	m_Rbus;
	BOOL	m_IntOnRCA;
	BOOL	m_RTS_RTXC;
	BOOL	m_RTSCTSOut;
	BOOL	m_Slow;
	BOOL	m_IntOnSpecCond;
	BOOL	m_Stop;
	BOOL	m_IntOnSync;
	BOOL	m_IntOnTBE;
	BOOL	m_IntOnTMTUR;
	BOOL	m_IntOnZero;
	CString	m_WR0;
	CString	m_WR1;
	CString	m_WR10;
	CString	m_WR11;
	CString	m_WR12;
	CString	m_WR13;
	CString	m_WR14;
	CString	m_WR15;
	CString	m_WR2;
	CString	m_WR3;
	CString	m_WR4;
	CString	m_WR5;
	CString	m_WR6;
	CString	m_WR7;
	CString	m_WR7PR;
	CString	m_WR8;
	CString	m_WR9;
	CString	m_RR;
	DWORD	m_Baudrate;
	UINT	m_usBoard;
	UINT	m_usChannel;
	UINT	m_usSlot;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CTestxsccDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CTestxsccDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnButtonCtrl();
	afx_msg void OnButtonInt();
	afx_msg void OnButtonWr0();
	afx_msg void OnButtonWr1();
	afx_msg void OnButtonWr2();
	afx_msg void OnButtonWr3();
	afx_msg void OnButtonWr4();
	afx_msg void OnButtonWr5();
	afx_msg void OnButtonWr6();
	afx_msg void OnButtonWr7();
	afx_msg void OnButtonWr8();
	afx_msg void OnButtonWr9();
	afx_msg void OnButtonWr10();
	afx_msg void OnButtonWr11();
	afx_msg void OnButtonWr12();
	afx_msg void OnButtonWr13();
	afx_msg void OnButtonWr14();
	afx_msg void OnButtonWr15();
	afx_msg void OnButtonWr7p();
	afx_msg void OnCheckStop();
	afx_msg void OnCheckSlow();
	afx_msg void OnCheckRbus();
	afx_msg void OnCheckRtsctsout();
	afx_msg void OnButtonAsync();
	afx_msg void OnButtonTmt();
	afx_msg void OnButtonStart();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_TESTXSCCDLG_H__50BFD112_A07E_443B_A0A2_C50395A6D145__INCLUDED_)
